#include <GMLuaModule.h>

#include <tier0\dbg.h>

GMOD_MODULE(Open, Close);

ILuaInterface *gLua = NULL;

SpewOutputFunc_t oldSpewFunction = NULL;

SpewRetval_t SpewFunction(SpewType_t spewType, const tchar *pMsg)
{
	ILuaObject *hookT = gLua->GetGlobal("hook");
		gLua->Push(hookT->GetMember("Call"));

		gLua->Push("EngineSpew");
		gLua->PushNil();
		gLua->PushDouble(spewType);
		gLua->Push(pMsg);
		
		gLua->Call(4, 1);
	hookT->UnReference();

	if (gLua->GetReturn(0)->isNil())
		return oldSpewFunction(spewType, pMsg);
	else
		return SPEW_CONTINUE;
}

int Open(lua_State *L)
{
	gLua = Lua();

	oldSpewFunction = GetSpewOutputFunc();

	SpewOutputFunc(SpewFunction);

	return 0;
}

int Close(lua_State *L)
{
	SpewOutputFunc(oldSpewFunction);

	return 0;
}